<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="知识点名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入知识点名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="父ID" prop="pid">
        <el-input v-model="queryParams.pid" placeholder="请输入父ID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="祖级列表" prop="ancestors">
        <el-input v-model="queryParams.ancestors" placeholder="请输入祖级列表" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="科目id" prop="subjectId">
        <el-input v-model="queryParams.subjectId" placeholder="请输入科目id" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input v-model="queryParams.sort" placeholder="请输入排序" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="级数" prop="level">
        <el-input v-model="queryParams.level" placeholder="请输入级数" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="题目数" prop="questionsCount">
        <el-input v-model="queryParams.questionsCount" placeholder="请输入题目数" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="适用省份" prop="locations">
        <el-input v-model="queryParams.locations" placeholder="请输入适用省份" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="适用考生类型" prop="examineeTypes">
        <el-input v-model="queryParams.examineeTypes" placeholder="请输入适用考生类型" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:knowledgeTree:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:knowledgeTree:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:knowledgeTree:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:knowledgeTree:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="knowledgeTreeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" fixed="left" />
      <!-- <el-table-column label="知识点id" align="center" prop="id" fixed="left" /> -->
      <el-table-column label="知识点名称" prop="name" fixed="left" header-align="center" align="left"
        min-width="200" />
      <el-table-column label="父ID" align="center" prop="pid" />
      <el-table-column label="祖级列表" align="center" prop="ancestors" />
      <el-table-column label="科目id" align="center" prop="subjectId" />
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="级数" align="center" prop="level" />
      <el-table-column label="题目数" align="center" prop="questionsCount" />
      <el-table-column label="适用省份" align="center" prop="locations" />
      <el-table-column label="适用考生类型" align="center" prop="examineeTypes" min-width="120" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="140" fixed="right">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:knowledgeTree:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:knowledgeTree:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改知识点树对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="knowledgeTreeRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="知识点名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入知识点名称" />
        </el-form-item>
        <el-form-item label="父ID" prop="pid">
          <el-input v-model="form.pid" placeholder="请输入父ID" />
        </el-form-item>
        <el-form-item label="科目id" prop="subjectId">
          <el-input v-model="form.subjectId" placeholder="请输入科目id" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="级数" prop="level">
          <el-input v-model="form.level" placeholder="请输入级数" />
        </el-form-item>
        <el-form-item label="题目数" prop="questionsCount">
          <el-input v-model="form.questionsCount" placeholder="请输入题目数" />
        </el-form-item>
        <el-form-item label="适用省份" prop="locations">
          <el-input v-model="form.locations" placeholder="请输入适用省份" />
        </el-form-item>
        <el-form-item label="适用考生类型" prop="examineeTypes">
          <el-input v-model="form.examineeTypes" placeholder="请输入适用考生类型" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="KnowledgeTree">
import { listKnowledge, getKnowledgeTree, delKnowledgeTree, addKnowledgeTree, updateKnowledgeTree } from "@/api/learn/knowledgeTree"

const { proxy } = getCurrentInstance()

const knowledgeTreeList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: null,
    pid: null,
    ancestors: null,
    subjectId: null,
    sort: null,
    level: null,
    questionsCount: null,
    locations: null,
    examineeTypes: null
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询知识点树列表 */
function getList() {
  loading.value = true
  listKnowledge(queryParams.value).then(response => {
    knowledgeTreeList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    name: null,
    pid: null,
    ancestors: null,
    subjectId: null,
    sort: null,
    level: null,
    questionsCount: null,
    locations: null,
    examineeTypes: null
  }
  proxy.resetForm("knowledgeTreeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加知识点树"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getKnowledgeTree(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改知识点树"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["knowledgeTreeRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateKnowledgeTree(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addKnowledgeTree(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除知识点树编号为"' + _ids + '"的数据项？').then(function () {
    return delKnowledgeTree(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/knowledgeTree/export', {
    ...queryParams.value
  }, `knowledgeTree_${new Date().getTime()}.xlsx`)
}

getList()
</script>
